//Initializing vars
local hasStepped = 0



//Freeslotting sounds
freeslot(
	"sfx_kstep1",
	"sfx_fstep0",
	"sfx_msjet0"
)



//Captions
sfxinfo[sfx_kstep1] = {
	singular = false,
	caption = "Heavy step"
}
sfxinfo[sfx_fstep0] = {
	singular = false,
	caption = "Step"
}
sfxinfo[sfx_msjet0] = {
	singular = false,
	caption = "Roll"
}



addHook("PlayerThink", function(player)
	if player.mo.skin == "forest"
	
		//Footstepping each frame; sound depends on player speed
		if (player.mo.state == S_PLAY_WALK
		and (player.mo.frame == 0
		or player.mo.frame == 4))
		or (player.mo.state == S_PLAY_RUN
		and (player.mo.frame == 1
		or player.mo.frame == 3))
		and P_IsObjectOnGround(player.mo)
		and not ((player.mo.eflags & MFE_TOUCHWATER) and not (player.mo.eflags & MFE_UNDERWATER))
			if not hasStepped
				hasStepped = 1
				if FixedHypot(player.mo.momx, player.mo.momy) > 50*FRACUNIT
					P_SpawnSkidDust(player, 10*FRACUNIT)
					S_StartSound(player.mo, sfx_kstep1)
				else
					if player.mo.state == S_PLAY_RUN
						S_StartSound(player.mo, sfx_fstep0)
					else
						S_StartSoundAtVolume(player.mo, sfx_fstep0, 128)
					end
				end
				if player.mo.state == S_PLAY_RUN
					P_SpawnSkidDust(player, 10*FRACUNIT)
				end
			end
		else
			hasStepped = 0
		end
		
		//Rolling
		if (player.pflags & PF_SPINNING)
		and P_IsObjectOnGround(player.mo)
			if not S_SoundPlaying(player.mo, sfx_msjet0)
				if FixedInt(FixedHypot(player.mo.momx, player.mo.momy)*4) < 255
				or (player.pflags & PF_STARTDASH)
					S_StartSoundAtVolume(player.mo, sfx_msjet0, FixedInt(FixedHypot(player.mo.momx, player.mo.momy)*4))
				else
					S_StartSound(player.mo, sfx_msjet0)
					//s3kbcs
				end
			end
			if FixedHypot(player.mo.momx, player.mo.momy) >= 15*FRACUNIT
				P_SpawnSkidDust(player, 10*FRACUNIT)
			end
			if FixedHypot(player.mo.momx, player.mo.momy) > 50*FRACUNIT
				P_SpawnSkidDust(player, 10*FRACUNIT)
			end
		end
		
		//Spindashing
		if player.mo.state == S_PLAY_SPINDASH
			if not S_SoundPlaying(player.mo, sfx_msjet0)
				S_StartSound(player.mo, sfx_msjet0)
			end
		end
		
		//Landing
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and not player.exiting
		and player.mo.health
		and not player.wasJustlaunched
		//and player.prevmomz < -FRACUNIT
			if (player.pflags & PF_SPINNING)
				if not player.stomping
					S_StartSound(player.mo, sfx_s3k5d)
				end
			else
				S_StartSound(player.mo, sfx_s3k4c)
			end
			//kc50
			for i=0,5,1 do
				P_SpawnSkidDust(player, 25*FRACUNIT)
			end
		end
	end
end, MT_PLAYER)