// sloperollangle.lua by Golden
// Angles characters on the side of slopes without requiring additional sprites.
// v3 now includes the togglable ability to use camera rolling. Default off, because motion sickness.

// hello hacker fucker this is golden heres the deal. if you steal this lua i will find you and break your legs and thats a promise

local cv_cameraroll = CV_RegisterVar{"cameraroll", "Off", CV_SAVE|CV_CALL|CV_NOINIT|CV_SHOWMODIF, CV_OnOff,
	do
		if not maptol then
			print("Please be ingame for the change to take effect.")
		end
	end
}
print('Registered console variable "cameraroll"')

local cv_cam_rollspeed = CV_RegisterVar{"cam_rollspeed", "0.1", CV_FLOAT|CV_SAVE|CV_SHOWMODIF, {MIN=0, MAX=FRACUNIT}}
print('Registered console variable "cam_rollspeed"')

CV_RegisterVar{"cv_", "off", CV_NETVAR, CV_OnOff, func}

// Centers you!
local function resetRollAngle(rollangle)
	// The speed at which you are centered at.
	local speed = FixedAngle(6*FRACUNIT)

	if rollangle > FixedAngle(0) + speed then // rollangle more than centered + centering speed?
		rollangle = $ - speed // Subtract the speed!
	elseif rollangle < FixedAngle(0) - speed then // rollangle less than centered - centering speed?
		rollangle = $ + speed // Add the speed!
	else // rollangle between +centering speed and -centering speed?
		rollangle = FixedAngle(0) // Center!
	end

	return rollangle // Return the resulting rollangle.
end

local function getSlopeAngleForRollAngle(mo, dontflip)
	if mo and mo.skin == "forest"
	local lookAngle = R_PointToAngle(mo.x, mo.y) // Get the angle that we're looking from.

	if not R_PointToDist(mo.x, mo.y) then // Camera at player?
		lookAngle = mo.angle // Use player angle instead of whatever R_PointToAngle generates..
	end

	// zangle and direction of the slope we're on (if any).
	local zangle = mo.standingslope.zangle
	local xydirection = mo.standingslope.xydirection

	if mo.eflags & MFE_VERTICALFLIP and not dontflip then // Flipped?
		zangle = InvAngle(zangle) // Flip the zangle too!
	end

	// Fancy angle math that rolls the sprite against the slope.
	// Trust me on this one.
	return FixedMul(zangle, sin(lookAngle - xydirection))
	end
end

local function normalPlayerStuff(mo)
	if mo and mo.skin == "forest"
	// Generic sanity checks.
	if not mo.subsector or not mo.subsector.valid
	or not mo.subsector.sector or not mo.subsector.sector.valid then
		return
	end

	local player = mo.player // Get player
	local sector = mo.subsector.sector // Get sector

	if not P_IsObjectOnGround(mo) then // Off the ground?
		if not player.sloperollangle_override then
			mo.rollangle = resetRollAngle(mo.rollangle) // Center that rollangle!
		end

		if cv_cameraroll.value and player.viewrollangle ~= nil then // They've enabled the camera rolling?
			player.viewrollangle = FixedMul($, FRACUNIT - cv_cam_rollspeed.value) // Smoothly reset it to 0.
		end

		return // Don't continue.
	end

	if player.pflags & PF_SPINNING and mo.standingslope then // Spinning?
		if not player.sloperollangle_override then
			mo.rollangle = FixedAngle(0) // Reset rollangle.
		end

		if cv_cameraroll.value and player.viewrollangle ~= nil then // They've enabled the camera rolling?
			// Instead of resetting,
			// calculate the normal camera rolling.
			// Spinning shouldn't effect the camera roll!
			player.viewrollangle = $ - FixedMul(getSlopeAngleForRollAngle(mo, true) + $, cv_cam_rollspeed.value)
		end

		return // Don't continue.
	elseif not mo.standingslope then // No slope?
		if not player.sloperollangle_override then
			mo.rollangle = FixedAngle(0) // Reset rollangle.
		end

		if cv_cameraroll.value and player.viewrollangle ~= nil then // They've enabled the camera rolling?
			// Adjust camera for maximum motion sickness.
			player.viewrollangle = FixedMul($, FRACUNIT - cv_cam_rollspeed.value) // Smoothly reset it to 0.
		end

		return // Don't continue.
	end

	// Use fancy formula that sets the player's roll angle to what it should be.
	if not player.sloperollangle_override then
		mo.rollangle = getSlopeAngleForRollAngle(mo)
	end

	if cv_cameraroll.value and player.viewrollangle ~= nil then // They've enabled the camera rolling?
		// Adjust camera for maximum motion sickness.
		player.viewrollangle = $ - FixedMul(getSlopeAngleForRollAngle(mo, true) + $, cv_cam_rollspeed.value)
	end
	end
end

local function mobjThinker(mo)
	if mo and mo.skin == "forest"
	// Generic sanity checks.
	if not mo.player or not mo.player.valid then
		return
	end

	local player = mo.player

	if cv_cameraroll.value and player.viewrollangle == nil and leveltime > 0 then // Viewroll on, nil viewroll, and printable?
		// Uh oh, we got a problem!
		print(
			'\x80You do not have an EXE that supports view rolling!' .. '\n'
			.. 'Please download ' .. '\x83' .. 'Fickle\'s viewroll EXE\x80, or ' .. '\x83' .. 'a newer version of SRB2\x80.'
		)
		COM_BufInsertText(player, "cameraroll 0") // Reset cameraroll so we don't get the error again.
	elseif not cv_cameraroll.value and player.viewrollangle ~= nil then // Off, but viewroll exists?
		player.viewrollangle = FixedMul($, FRACUNIT - cv_cam_rollspeed.value) // Smoothly reset it to 0.
	end

	if not (maptol & TOL_NIGHTS) then // NiGHTS?
		normalPlayerStuff(mo)
	end
	end
end

// Tails overlay thinker, for Tails' tails.
local function tailsOverlay(tails)
	// Check if Tails exists.
	if not tails.tracer or not tails.tracer.valid
	or not tails.tracer.player or not tails.tracer.player.valid then
		return
	end

	local mo = tails.tracer // Get Tails's mobj.

	if not mo.player.sloperollangle_override then
		tails.rollangle = mo.rollangle // Set our rollangle to Tails's rollangle.
	end

	// ~ Fin ~
end

// Add le hooks.
addHook("MobjThinker", mobjThinker, MT_PLAYER)
addHook("MobjThinker", tailsOverlay, MT_TAILSOVERLAY)