//Initializing var
local wasOnGround = 0



addHook("PlayerThink", function(player)
	if (player.mo.skin == "forest")
	
		//Initializing vars
		if player.scaledbefore == nil
			player.scaledbefore = 1
			player.spriteyscalecount = FRACUNIT*3/4
		end
		
		if not player.powers[pw_carry]
			//Squish if floor hit
			if ((P_IsObjectOnGround(player.mo) and not (player.pflags & PF_JUMPED)) or (S_SoundPlaying(player.mo, sfx_3db16) and player.curled and (P_IsObjectOnGround(player.mo) or not wasOnGround)) or player.bounced)
			and player.scaledbefore == 0
			and not (player.spriteyscalecount > FRACUNIT)
				player.mo.spriteyscale = player.spriteyscalecount
				player.spriteyscalecount = $+5000
				if player.spriteyscalecount > FRACUNIT
					player.scaledbefore = 1
				end
			else
			
				//Reset so you can squish again
				if ((player.mo.eflags & MFE_JUSTHITFLOOR) or not (P_IsObjectOnGround(player.mo) or player.curled) or player.stomping)
					player.scaledbefore = 0
					player.spriteyscalecount = FRACUNIT*3/4
				end
				
				//Stretching while rising or falling (does more when rolling state plays)
				if not P_IsObjectOnGround(player.mo)
					if player.mo.state == S_PLAY_ROLL
					or (not (player.charflags & SF_NOJUMPSPIN) and player.mo.state == S_PLAY_JUMP)
						player.mo.spriteyscale = ease.outexpo(abs(player.mo.momz)/24, FRACUNIT*63/64, FRACUNIT*3/2)
					else
						player.mo.spriteyscale = ease.outexpo(abs(player.mo.momz)/24, FRACUNIT*63/64, FRACUNIT*7/6)
					end
				end
				
				//Sprite offsets
				if player.mo.spriteyscale >= FRACUNIT*63/64
				and not P_IsObjectOnGround(player.mo)
				and (player.mo.state == S_PLAY_ROLL
				or (not (player.charflags & SF_NOJUMPSPIN) and player.mo.state == S_PLAY_JUMP))
					player.mo.spriteyoffset = -32*player.mo.spriteyscale + 48*FRACUNIT
					//The stuff added to spriteyscale must always be 1.5x the multiple of spriteyscale
				end
			end
		else
			//In case player is being carried, have no scaling
			player.mo.spriteyscale = FRACUNIT
			player.mo.spriteyoffset = 0
		end
		
		//Making the player's x scale go in proportion to the y
		player.mo.spritexscale = FixedDiv(FRACUNIT, player.mo.spriteyscale)
		
		//Fixing offset if on ground
		if P_IsObjectOnGround(player.mo)
			player.mo.spriteyoffset = 0
		end
		
		//Previous frame checks
		if P_IsObjectOnGround(player.mo)
			wasOnGround = 1
		else
			wasOnGround = 0
		end
	end
end, MT_PLAYER)