//Initializing vars
/*local comboScore = 0
local comboScoreMax = 20*TICRATE
local addToScore = 0
local comboDelay = 0
local quakeTimer = 0
local bankLimiter = 3
local isForest = 0



//Reset score on respawn
addHook("PlayerSpawn", function(player)
	if player.mo.skin == "forest"
		comboScore = 0
		comboDelay = 0
		bankLimiter = 3
	end
end)



//Resetting bank limiter when map changes
/*addHook("MapChange", function()
	if isForest then bankLimiter = 3 end
end)*/


/*
//Adds to score if enemy is damaged
addHook("MobjDamage", function(mobj,mo)
	if (mo and mo.valid and mo.skin == "forest")
	and (mobj.flags & (MF_ENEMY|MF_BOSS))
		if mo.player.powers[pw_super]
			P_GivePlayerRings(mo.player, 6)
		else
			comboScore = $+2*TICRATE
		end
	end
end)



addHook("PlayerThink", function(player)
	if player.mo.skin == "forest"
		isForest = 1
		
		//Adding to score based on speed
		if (not player.powers[pw_super] and FixedHypot(player.mo.momx, player.mo.momy) > 80*FRACUNIT)
		or (player.powers[pw_super] and FixedHypot(player.mo.momx, player.mo.momy) > 100*FRACUNIT)
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 5
			addToScore = $+2
		elseif (not player.powers[pw_super] and FixedHypot(player.mo.momx, player.mo.momy) > 50*FRACUNIT)
		or (player.powers[pw_super] and FixedHypot(player.mo.momx, player.mo.momy) > 85*FRACUNIT)
			addToScore = $+1
		elseif FixedHypot(player.mo.momx, player.mo.momy) < player.runspeed
		and abs(FixedMul(player.mo.momz, FRACUNIT/-32768*P_GetMobjGravity(player.mo))) < 8*FRACUNIT
			addToScore = $-1
		end
		
		//Limiting the amount of times you can bank per stage
		if not bankLimiter
			comboScore = 0
			comboDelay = (comboScore-$)/4 + $
			
		//Adding to ring counter
		elseif player.powers[pw_super]
			comboScore = 0
			comboDelay = comboScoreMax
			if addToScore > 0 and not ((leveltime % TICRATE) - 1)
				P_GivePlayerRings(player, 2)
				if addToScore > 1 and not ((leveltime % (TICRATE/addToScore)) - 1)
					P_GivePlayerRings(player, 1)
				end
			elseif addToScore < 0 and not ((leveltime % TICRATE/abs(addToScore)) - (1 + TICRATE/2))
				P_GivePlayerRings(player, -1)
			end
			
		//Making player either earn 5000 points or go super when comboScore is maxed out
		elseif comboScore > comboScoreMax
			if All7Emeralds(emeralds)
				if P_IsObjectOnGround(player.mo)
					player.charflags = $&~SF_NOJUMPDAMAGE
					P_DoJump(player)
					P_SetObjectMomZ(player.mo, 16*player.zWaterMul)
				elseif FixedMul(player.mo.momz, FRACUNIT/-32768*P_GetMobjGravity(player.mo)) < -2*FRACUNIT
				and FixedMul(player.mo.momz, FRACUNIT/-32768*P_GetMobjGravity(player.mo)) > -4*FRACUNIT
					P_DoSuperTransformation(player, true)
					comboScore = 0
				end
			else
				P_AddPlayerScore(player, 5000)
				S_StartSound(player.mo, sfx_chchng, true)
				bankLimiter = $-1
				comboScore = 0
			end
		
		//Adding to comboScore
		else
			if addToScore != -1
			or not (leveltime % 2)
				comboScore = $+addToScore
			end
			if P_PlayerInPain(player)
				quakeTimer = TICRATE/8
				comboScore = 0
			elseif comboScore < 0
				comboScore = 0
			end
			comboDelay = (comboScore-$)/4 + $
		end
		addToScore = 0
		
	else
		isForest = 0
	end
end,MT_PLAYER)



//Display combo meter
local function ComboMeter(v, player)
	if (player.mo.skin == "forest")
		//v.draw(0, 0, v.cachePatch("FORST"), V_HUDTRANS, v.getColormap(TC_DEFAULT, player.skincolor))
		local shakeX
		local shakeY
		if player.powers[pw_super]
			shakeX = v.RandomRange(-1, 1)
			shakeY = v.RandomRange(-1, 1)
			v.drawFill(4 + shakeX, 28 + shakeY, 80, 2, 31, V_HUDTRANS|V_SNAPTOLEFT)
			for i=0,15,1 do
				v.drawFill(4 + shakeX + i*5, 28 + shakeY, 5, 2, skincolors[player.mo.color].ramp[i], V_HUDTRANS|V_SNAPTOLEFT)
			end
		elseif quakeTimer
			quakeTimer = $-1
			shakeX = v.RandomRange(-1, 1)
			shakeY = v.RandomRange(-1, 1)
			v.drawFill(4 + shakeX, 28 + shakeY, 80, 2, 31, V_SNAPTOLEFT)
			v.drawFill(4 + shakeX, 28 + shakeY, comboScore*80/comboScoreMax, 2, skincolors[SKINCOLOR_FLAME].ramp[4], V_HUDTRANS|V_SNAPTOLEFT)
			v.drawFill(4 + shakeX, 28 + shakeY, comboDelay*80/comboScoreMax, 2, skincolors[player.mo.color].ramp[4], V_HUDTRANS|V_SNAPTOLEFT)
		else
			shakeX = 0
			shakeY = 0
			if bankLimiter
				v.drawFill(4, 28, 80, 2, 31, V_HUDTRANS|V_SNAPTOLEFT)
			else
				v.drawFill(4, 28, 80, 2, 0, V_HUDTRANS|V_SNAPTOLEFT)
			end
			v.drawFill(4, 28, comboScore*80/comboScoreMax, 2, skincolors[SKINCOLOR_FLAME].ramp[4], V_HUDTRANS|V_SNAPTOLEFT)
			v.drawFill(4, 28, comboDelay*80/comboScoreMax, 2, skincolors[player.mo.color].ramp[4], V_HUDTRANS|V_SNAPTOLEFT)
		end
	end
end
hud.add(ComboMeter)*/