//Initialize vars
local uncurlTimer = 0
local wasUse = 0
local wasSpindash = 0
local wasGrounded = 0
local noSound = 0



//Curling when jumping
addHook("JumpSpecial", function(player)
	if (player.mo.skin == "forest")
	and (P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_JUSTHITFLOOR))
	and not player.wasJump
		//print("player.curling")
		player.scaledbefore = 1
		player.spriteyscalecount = FRACUNIT
		player.charflags = $&~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
		noSound = 1
		player.curling = 1
		uncurlTimer = 3
	end
end,MT_PLAYER)



//Curling while rolling
addHook("SpinSpecial", function(player)
	if (player.mo.skin == "forest")
	and ((P_IsObjectOnGround(player.mo) and not (player.pflags & PF_SPINNING) and not (player.pflags & PF_STARTDASH))
	or (not P_IsObjectOnGround(player.mo) and not (player.mo.state == S_PLAY_ROLL)))
	and not player.curling
		//print("player.curling")
		player.curling = 1
		uncurlTimer = 3
	end
end, MT_PLAYER)



//Fixing spin gaps
addHook("PlayerCanEnterSpinGaps", function(player)
	if player.mo.skin == "forest"
	and not player.curled
		player.pflags = $|PF_SPINNING
		player.curled = 1
		player.curling = 1
	end
end, MT_PLAYER)



addHook("PlayerThink", function(player)
	if player.mo.skin == "forest"
		
		//Initializing relevant player vars
		if player.curled == nil
			player.curled = 0
			player.curling = 0
			player.wasJump = 0
		end
		
		
		//Setting vars
		//player.curling
		if player.launching
			//print("player.curling")
			noSound = 1
			player.curled = 0
			player.curling = 1
			uncurlTimer = 12
			//uncurlTimer = 9
		end
		//Uncurling
		if not (player.cmd.buttons & BT_SPIN)
		and ((wasUse
		and not wasSpindash
		and not player.dashing
		and (P_IsObjectOnGround(player.mo) and (player.pflags & PF_SPINNING)
		or not P_IsObjectOnGround(player.mo)))
		or ((player.mo.eflags & MFE_JUSTHITFLOOR) and not ((player.cmd.buttons & BT_JUMP) and not player.wasJump)))
		//and not uncurlTimer
			//print("unplayer.curling")
			player.curling = 0
			uncurlTimer = 3
		end
		//Curled
		if (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		or (player.dashing and not player.powers[pw_super])
		or (player.pflags & PF_STARTDASH)
		or player.powers[pw_carry]
			//print("curled")
			player.curled = 1
			player.curling = 1
		end
		//Uncurled
		if (player.mo.eflags & MFE_SPRUNG)
		or P_PlayerInPain(player)
		or not player.mo.health
		or (P_IsObjectOnGround(player.mo) and FixedHypot(player.mo.momx, player.mo.momy) < 4*FRACUNIT and not (player.pflags & PF_STARTDASH) and not (player.mo.eflags & MFE_SPRUNG))
		or ((player.mo.eflags & MFE_JUSTHITFLOOR) and not (player.cmd.buttons & BT_SPIN))
		or (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		or (player.mo.state >= S_PLAY_NIGHTS_TRANS1 and player.mo.state <= S_PLAY_NIGHTS_ATTACK)
		or (player.dashing and player.powers[pw_super])
			//print("uncurled")
			player.curled = 0
			player.curling = 0
		end
		//Curling jump (special case)
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.buttons & BT_JUMP) and not player.wasJump)
			player.charflags = $&~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
			noSound = 1
			player.curling = 1
			uncurlTimer = 3
		end
		//Special case launched by roll zoom pads (or anything else that forces the player into a rolling state)
		if ((player.pflags & PF_SPINNING) and not (player.curled or player.curling) and P_IsObjectOnGround(player.mo))
			//print("curled")
			player.curled = 1
			player.curling = 1
		end
		//(player.cmd.buttons & BT_SPIN) or wasUsed or 
		
		
		if not (player.pflags & PF_STARTDASH)
		and not player.powers[pw_carry]
		
			//Changing curl
			//Going from uncurl to curl
			if player.curling
			and not player.curled
				//print("player.curling")
				if uncurlTimer
					uncurlTimer =$-1
					player.pflags = $&~PF_SPINNING
					if player.mo.state != S_PLAY_SPRING
						player.mo.state = S_PLAY_SPRING
					end
					if not P_IsObjectOnGround(player.mo)
						player.charflags = $|SF_NOJUMPSPIN|SF_NOJUMPDAMAGE
					end
				else
					player.curled = 1
					if not noSound
						S_StartSound(player.mo, sfx_3db16)
					else
						noSound = 0
					end
					if player.mo.state != S_PLAY_ROLL
						player.mo.state = S_PLAY_ROLL
					end
					player.scaledbefore = 0
					player.spriteyscalecount = FRACUNIT*3/4
				end
			end
			//Going from curl to uncurl
			if not player.curling
			and player.curled
				//print("unplayer.curling")
				if uncurlTimer
					uncurlTimer =$-1
					if not P_IsObjectOnGround(player.mo)
						player.charflags = $&~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
						if player.mo.state != S_PLAY_SPRING
							player.mo.state = S_PLAY_SPRING
						end
					else
						player.pflags = $|PF_SPINNING
					end
				else
					player.curled = 0
					if P_IsObjectOnGround(player.mo)
						if FixedHypot(player.mo.momx, player.mo.momy) == 0
							player.mo.state = S_PLAY_STND
						elseif FixedHypot(player.mo.momx, player.mo.momy) < player.runspeed
							player.mo.state = S_PLAY_WALK
						else
							player.mo.state = S_PLAY_RUN
						end
					else
						if player.mo.momz * P_MobjFlip(player.mo) > 0
							player.mo.state = S_PLAY_SPRING
						else
							player.mo.state = S_PLAY_FALL
						end
					end
				end
			end

			
			
			//Retaining states
			//Keeping curl
			if player.curling
			and player.curled
			and ((P_IsObjectOnGround(player.mo) and (FixedHypot(player.mo.momx, player.mo.momy) > 4*FRACUNIT))
			or not P_IsObjectOnGround(player.mo))
				//print("curled")
				player.charflags = $&~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
				if P_IsObjectOnGround(player.mo)
					player.pflags = $|PF_SPINNING
					if player.mo.state != S_PLAY_ROLL
						player.mo.state = S_PLAY_ROLL
					end
				else
					if player.mo.state != S_PLAY_JUMP
					and player.mo.state != S_PLAY_GASP
						player.mo.state = S_PLAY_JUMP
					end
				end
			end
			//Keeping uncurl
			if not player.curling
			and not player.curled
				//print("uncurled")
				noSound = 0
				player.pflags = $&~PF_SPINNING
				if not P_IsObjectOnGround(player.mo)
					player.charflags = $|SF_NOJUMPSPIN|SF_NOJUMPDAMAGE
				end
			end
		end
		
		
		
		//Previous frame checks
		if (player.cmd.buttons & BT_SPIN)
			wasUse = 1
		else
			wasUse = 0
		end
		if (player.cmd.buttons & BT_JUMP)
			player.wasJump = 1
		else
			player.wasJump = 0
		end
		if (player.pflags & PF_STARTDASH)
			wasSpindash = 1
		else
			wasSpindash = 0
		end
		
		//print(player.pflags & PF_JUMPED)
		//player.charflags & SF_NOJUMPDAMAGE
		
	end
end, MT_PLAYER)