//Initializing vars
local wasC1 = 0
local prevMomz = 0
local prevSpeed = 0
local stompStrength = 0



//Freeslotting sounds
freeslot(
	"sfx_stomp"
)



//Captions
sfxinfo[sfx_stomp] = {
	singular = false,
	caption = "Stomp"
}



//Bouncing off of objects
local function ObjectBounce(mobj,mo)
	if (mo.player.cmd.buttons & BT_CUSTOM1)
		S_StartSoundAtVolume(mo, sfx_kc4c, 128)
		P_SetObjectMomZ(mo, -5*FRACUNIT, true)
		if abs(mo.momz) < 11*FRACUNIT/-32768*P_GetMobjGravity(mo)
			P_SetObjectMomZ(mo, 11*FRACUNIT/-32768*P_GetMobjGravity(mo))
		end
	else
		S_StartSound(mo, sfx_cybdth)
		P_SetObjectMomZ(mo, 11*FRACUNIT/-32768*P_GetMobjGravity(mo))
	end
end



//Adjusting hitting enemies
addHook("MobjDamage", function(mobj,mo)
	if (mo and mo.valid and mo.skin == "forest")
	and not P_IsObjectOnGround(mo)
	and (mobj.flags & (MF_ENEMY|MF_BOSS))
	and mo.player.stomping
		ObjectBounce(mobj,mo)
	end
end)



//Adjusting hitting monitors
addHook("MobjDeath", function(mobj,mo)
	if (mo and mo.valid and mo.skin == "forest")
	and not P_IsObjectOnGround(mo)
	and (mobj.flags & MF_MONITOR)
	and mo.player.stomping
		ObjectBounce(mobj,mo)
	end
end)



addHook("PlayerThink", function(player)
	if player.mo.skin == "forest"
		
		if player.stomping == nil
			player.stomping = 0
			player.bounced = 0
		end
		
		//Marking the player as not bounced under certain circumstances
		if P_IsObjectOnGround(player.mo)
		or player.stomping
		or not player.curled
			player.bounced = 0
		end
		
		if not P_IsObjectOnGround(player.mo)
			if not player.exiting
			and player.mo.health
			and not (P_PlayerInPain(player))
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.powers[pw_carry]
			and not player.dashing
				
				//Starting stomp
				if not player.stomping
				and (player.cmd.buttons & BT_CUSTOM1)
				and not wasC1
					player.stomping = 1
					player.curling = 1
					player.curled = 1
					S_StartSoundAtVolume(player.mo, sfx_kc4d, 128)
					//s3ka2
					P_SpawnTechTrail(player, false)
					/*for i=0,10,1 do
						P_SpawnSkidDust(player, 25*FRACUNIT)
					end*/
					if player.powers[pw_super]
						P_SetObjectMomZ(player.mo, -20*FRACUNIT-abs(player.mo.momz))
					else
						P_SetObjectMomZ(player.mo, -15*FRACUNIT-abs(player.mo.momz))
					end
					stompStrength = abs(player.mo.momz)
					
				//During stomp
				elseif player.mo.momz * P_MobjFlip(player.mo) < 0
				and player.stomping
					player.curling = 1
					player.curled = 1
					player.powers[pw_strong] = $|STR_FLOOR|STR_SPRING
					//P_SpawnTechTrail(player, false)
				else
				
				//Resetting stomp
					player.powers[pw_strong] = $&~(STR_FLOOR|STR_SPRING)
					player.stomping = 0
				end
			else
				player.powers[pw_strong] = $&~(STR_FLOOR|STR_SPRING)
				player.stomping = 0
			end
			
		//Finishing stomp
		elseif player.stomping
			player.stomping = 0
			player.powers[pw_strong] = $&~(STR_FLOOR|STR_SPRING)
			
			
			//Stomp dashing
			if (player.cmd.buttons & BT_SPIN)
				S_StartSound(player.mo, sfx_zoom)
				S_StartSoundAtVolume(player.mo, sfx_kc31, 64)
				S_StartSoundAtVolume(player.mo, sfx_kc3d, 64)
				player.curling = 1
				player.curled = 1
				player.pflags = $|PF_SPINNING
				
				//Initial dash speed. Change this before the easer.
				local dashSpd = abs(prevMomz)-abs(stompStrength)*7/12 - 10*FRACUNIT
				//Easer/limiter so you don't go WHEE if you use it too high
				dashSpd = ease.outexpo($/24, 0, 25*FRACUNIT)
				
				if dashSpd > 0
				and dashSpd + prevSpeed > FixedHypot(player.mo.momx, player.mo.momy) - 2*FRACUNIT
					P_InstaThrust(player.mo, player.mo.angle, prevSpeed)
					P_Thrust(player.mo, player.mo.angle, dashSpd)
					player.speed = dashSpd + prevSpeed
				else
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), -2*FRACUNIT)
					player.speed = FixedHypot(player.mo.momx, player.mo.momy)-2*FRACUNIT
				end
				
				//Min and Max caps
				if player.speed < player.mindash
					P_InstaThrust(player.mo, player.mo.angle, player.mindash)
				elseif player.speed > prevSpeed + 25*FRACUNIT
					P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), prevSpeed + 25*FRACUNIT)
				end
				
				
			//Bouncing
			elseif (player.cmd.buttons & BT_CUSTOM1)
				player.curling = 1
				player.curled = 1
				player.bounced = 1
				S_StartSoundAtVolume(player.mo, sfx_kc40, 128)
				P_StartQuake(7*FRACUNIT*(1 + FixedInt(FixedHypot(player.mo.momx, player.mo.momy))/30), TICRATE/4)
				player.mo.momz = -prevMomz/32768*abs(P_GetMobjGravity(player.mo))
				P_SetObjectMomZ(player.mo, -stompStrength*7/12/32768*abs(P_GetMobjGravity(player.mo)), true)
				if abs(player.mo.momz) < 10*FRACUNIT/32768*abs(P_GetMobjGravity(player.mo))
					P_SetObjectMomZ(player.mo, 10*FRACUNIT/32768*abs(P_GetMobjGravity(player.mo)))
				end
				if FixedHypot(player.mo.momx, player.mo.momy) > player.runspeed
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), -5*FRACUNIT)
				end
				
			//Landing
			else
				P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), prevSpeed)
			end
		end
		
		
		//Previous frame checks
		if (player.cmd.buttons & BT_CUSTOM1)
			wasC1 = 1
		else
			wasC1 = 0
		end
		prevMomz = player.mo.momz
		prevSpeed = player.speed
		
	end
end,MT_PLAYER)